#include <afxwin.h>
#include "Resource.h"
#include "tetris.h"
#include "MIDI.h"
//************************************************************


int downratio=IDOWNRATIO;
bool kdown=false, kstopdown=false;
bool kclock=false;
bool kaclock=false;
bool kleft=false, knextleft=false;
bool kright=false, knextright=false;

int counter=1;
bool DownLockOff=true;
//************************************************************
CMyApp myApp;
CBitmap bCharset;
CBitmap bBlocks;
CBitmap bRight;
CMIDI myMidi;
CGrid grid;
//************************************************************

int CPiece::next()
{
	int ret=type;
	srand((int) GetCurrentTime());
	type=(rand())%7;
	rotation=0;
	return ret;
}

void CPiece::rotClock()
{
	rotation=(rotation==3)?0:rotation+1;
}

void CPiece::rotAClock()
{
	rotation=(rotation==0)?3:rotation-1;
}

int CPiece::getX(int block, int x)
{
	return x+blockData[type][rotation][block][0];
}
int CPiece::getY(int block, int y)
{
	return y+blockData[type][rotation][block][1];
}

void CPiece::DrawG(CDC* dc, int x, int y)
{
	CDC bDc;
	bDc.CreateCompatibleDC (dc);
	bDc.SelectObject (&bBlocks);
	const char (&blocks)[4][2]=blockData[type][rotation];

	for(int i=0;i<4;i++)
		if(type==6)
			dc->BitBlt(PIECEX+(x+blocks[i][0])*BRICKX,PIECEY+(y+blocks[i][1])*BRICKY,BRICKX,BRICKY,&bDc,0,BRICKY*line[rotation][i],SRCCOPY);
		else
			dc->BitBlt(PIECEX+(x+blocks[i][0])*BRICKX,PIECEY+(y+blocks[i][1])*BRICKY,BRICKX,BRICKY,&bDc,0,BRICKY*type,SRCCOPY);
}

void CPiece::EraseG(CDC* dc, int x, int y)
{
	const char (&blocks)[4][2]=blockData[type][rotation];

	for(int i=0;i<4;i++)
		dc->PatBlt(PIECEX+(x+blocks[i][0])*BRICKX,PIECEY+(y+blocks[i][1])*BRICKY,BRICKX,BRICKY,WHITENESS);
}
//******************************************************************************************
CGrid::CGrid()
	:ix(3),iy(-1),flash(0), ilines(0), ilevel(0), iscore(0)
{
	for(int i,j=0;j<GRIDY;j++)
		for(i=0;i<GRIDX;i++)
			store[j][i]=0;
}

bool CGrid::available(CPiece& piece, int ax, int ay)
{
	for(int i=0,x,y;i<4;i++)
	{
		x=piece.getX(i,ax);
		y=piece.getY(i,ay);
		if (/*y<0||*/x<0||x>=GRIDX||y>=GRIDY||((y<0)?false:store[y][x])) return false;
	}
	return true;
}

void CGrid::drawGridG()
{
	preview.DrawG(dc,PREVIEWX,PREVIEWY);
	bltGridG();
	piece.DrawG(dc,ix,iy);
}

void CGrid::bltGridG()
{
	CDC bDc;
	bDc.CreateCompatibleDC (dc);
	bDc.SelectObject (&bBlocks);
	for(int x,y=0;y<GRIDY;y++)
		for(x=0;x<GRIDX;x++)
			if(store[y][x])
				dc->BitBlt(PIECEX+x*BRICKX,PIECEY+y*BRICKY,BRICKX,BRICKY,&bDc,0,BRICKY*(store[y][x]-1),SRCCOPY);
			else
				dc->PatBlt(PIECEX+x*BRICKX,PIECEY+y*BRICKY,BRICKX,BRICKY,WHITENESS);
}

void CGrid::moveDownFullG()
{
	piece.EraseG(dc,ix,iy);
	while(available(piece, ix, iy))
	{
		iy++;
		downCount+=2;
	}
	piece.DrawG(dc,ix,--iy);
	downG();
}

bool CGrid::timerDownG()
{
	downCount=0;
	downG();
	return available(piece,ix,iy);
}

bool CGrid::moveDownG()
{
	downG();
	downCount++;
	return available(piece,ix,iy);
}

void CGrid::downG()
{
	if(available(piece, ix, iy+1))
	{
		piece.EraseG(dc,ix,iy);
		piece.DrawG(dc,ix,++iy);
	}
	else
	{
		GameMove(false);

		for(int i=0,j;i<4;i++)
			if(piece.type==6)
				store[piece.getY(i,iy)][piece.getX(i,ix)]=line[piece.rotation][i]+1;
			else
				store[piece.getY(i,iy)][piece.getX(i,ix)]=piece.type+1;
		for(lcount=0,j=0;j<GRIDY;j++)
		{
			for(i=0;i<GRIDX;i++)
				if(store[j][i]==0) break;
			if (i==GRIDX)
			{
				lines[lcount++]=j;
			}
		}
		if(downCount)
		{
			iscore+=downCount;
			downCount=0;
			printG(CGText(iscore),dc,(GRIDX+9)*BRICKX+1,3*BRICKY+1,true);
		}
		ix=3; iy=-1;
		piece=CPiece(preview.next(),0);
		kstopdown=true;
		kdown=false;
		if(lcount) flash=7;
		else
		{
			piece.EraseG(dc,PREVIEWX,PREVIEWY); //this is the old preview
			piece.DrawG(dc,ix,iy);
			preview.DrawG(dc,PREVIEWX,PREVIEWY);
			GameMove(true);
		}
	}
}

void CGrid::removeLinesG()
{
	int k=lcount;
	for(int y=lines[--k],x,i=1;y>=0;y--)
	{
		for(x=0;x<GRIDX;x++)
			store[y][x]=((y>=i)?store[y-i][x]:0);
		if(k>0)
			if(y==lines[k-1]+i)
			{
				i++;
				k--;
				y++;
			}
	}
	ilines+=lcount;
	int olevel=ilevel;
	ilevel=ilines/10;
	if(olevel!=ilevel) downratio=(ilevel>IDOWNRATIO)?1:(IDOWNRATIO-ilevel); //change timer ratio

	iscore+=lineScore[lcount-1]*(ilevel+1);
	updateInfoG();
	piece.EraseG(dc,PREVIEWX,PREVIEWY); //this is the old preview
	drawGridG(); //draws piece and preview as well
	GameMove(true);
}

void CGrid::updateInfoG()
{
	printG(CGText(ilines),dc,(GRIDX+8)*BRICKX+1,10*BRICKY+1,true);
	printG(CGText(ilevel),dc,(GRIDX+8)*BRICKX+1,7*BRICKY+1,true);
	printG(CGText(iscore),dc,(GRIDX+9)*BRICKX+1,3*BRICKY+1,true);
}

void CGrid::doFlashG()
{
	if(flash&1)
		for(int i=0;i<lcount;i++)
			dc->PatBlt(PIECEX,PIECEY+lines[i]*BRICKY,BRICKX*GRIDX,BRICKY,WHITENESS);
	else
	{
		CDC bDc;
		bDc.CreateCompatibleDC (dc);
		bDc.SelectObject (&bBlocks);
		for(int x,i=0,y;i<lcount;i++)
		{
			y=lines[i];
			for(x=0;x<GRIDX;x++) //show complete lines
				dc->BitBlt(PIECEX+x*BRICKX,PIECEY+y*BRICKY,BRICKX,BRICKY,&bDc,0,BRICKY*(store[y][x]-1),SRCCOPY);
		}
	}
	flash--;
	if(flash==0) removeLinesG();
}

void CGrid::moveLeftG()
{
	if(available(piece, ix-1, iy))
	{
		piece.EraseG(dc,ix,iy);
		piece.DrawG(dc,--ix,iy);
	}
}

void CGrid::moveRightG()
{
	if(available(piece, ix+1, iy))
	{
		piece.EraseG(dc,ix,iy);
		piece.DrawG(dc,++ix,iy);
	}
}

void CGrid::rotClockG()
{
	CPiece tmp(piece);
	tmp.rotClock();
	if(available(tmp, ix, iy))
	{
		piece.EraseG(dc,ix,iy);
		piece=tmp;
		piece.DrawG(dc,ix,iy);
	}
}

void CGrid::rotAClockG()
{
	CPiece tmp(piece);
	tmp.rotAClock();
	if(available(tmp, ix, iy))
	{
		piece.EraseG(dc,ix,iy);
		piece=tmp;
		piece.DrawG(dc,ix,iy);
	}
}

void CGrid::setDC(CDC *pdc)
{
	dc=pdc;
}

//******************************************************************************************
CGText::CGText()
:len(0) {}

CGText::CGText(chars chr)
:len(1)
{
	rep = new chars[1];
	rep[0]=chr;
}

CGText::CGText(const char* text)
{
	char c;
	len=strlen(text);
	rep=new chars[len];
	for(int i=0,j=0;i<len;i++,j++)
	{
		c=text[i];
		if(c>='0' && c<='9') rep[j]=c-'0'+c0;
		else if(c>='a' && c<='z') rep[j]=c-'a'+cA;
		else if(c>='A' && c<='Z') rep[j]=c-'Z'+cA;
		else if(c==' ') rep[j]=cSpace;
		else if(c=='-') rep[j]=cMinus;
		else if(c=='.') rep[j]=cDot;
		else if(c=='\n') rep[j]=cNewL;
		else j--;
	}
	len=j;
}

CGText::CGText(int num)
{
	chars buf[10];
	int i=0;
	do
	{
		buf[i++]=(num%10)+c0;
		num/=10;
	} while(num);
	
	rep=new chars[i];
	for(len=0;i>0;)
		rep[len++]=buf[--i];
	rep[len]+=1;
}

chars CGText::index(int i)
{
	return (i>len)?0:rep[i];
}
//	CGText operator+(CGText& other);
CGText::~CGText()
{
	len=0;
	delete [] rep;
}


void printG(CGText& text, CDC* pdc, int x, int y, bool right)
{
	CDC bDc;
	bDc.CreateCompatibleDC (pdc);
	bDc.SelectObject (&bCharset);

	int col=0;
	chars c;

	if(right) x-=text.len*8;
	for(int i=0;i<text.len;i++)
	{
		c=text.index(i);
		if(c==CGText::cNewL)
		{
			col=0;
			y+=8;
			continue;
		}
		else if(c!=CGText::cSpace)
			pdc->BitBlt(x+col*8,y,6,6,&bDc,0,6*c,SRCCOPY);
		col++;
	}
}

//******************************************************************************************
BEGIN_MESSAGE_MAP(CMainWindow, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_KEYUP()
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()

//******************************************************************************************
BOOL CMyApp::InitInstance()
{
	m_pMainWnd=new CMainWindow;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	m_pMainWnd->UpdateWindow();
	return TRUE;
}
//******************************************************************************************

void gameOver(CMainWindow* pWnd)
{
	myMidi.Stop();
	pWnd->MessageBox("Game Over!","Tetris",MB_ICONEXCLAMATION|MB_OK);
	exit(1);
}

void GameMove(bool start)
{
	DownLockOff=start;
//(if(start==true))
	counter=1;
}

UINT move(LPVOID lp)
{
	CMainWindow* pWnd= (CMainWindow*) lp;
	CDC* dc;

	for(;;)
	{
		
		if(DownLockOff)
		{
			dc=pWnd->GetDC();
			grid.setDC(dc);

			counter++;
				
				if(kdown) if(!grid.moveDownG()) gameOver(pWnd);
				if(!kdown)
				{
					if(counter%((downratio+3)>>2)==0)
					{
						if(knextleft) grid.moveLeftG();
						if(knextright) grid.moveRightG();
					}
					if(counter%downratio==0)
					{
						if(kleft) knextleft=true;
						if(kright) knextright=true;
						if(!grid.timerDownG()) gameOver(pWnd);
					}
				}
			pWnd->ReleaseDC(dc);
		}
		::Sleep(DELAY_MOVE);
	}
	return 0;
}

CMainWindow::CMainWindow()
{
	Create(NULL,"Tetris",WS_OVERLAPPED|WS_SYSMENU|WS_MINIMIZEBOX,CRect(CW_USEDEFAULT,CW_USEDEFAULT,PIECEX+GRIDX*BRICKX+56+18,GRIDY*BRICKY+29));
}

int CMainWindow::OnCreate(LPCREATESTRUCT lpcs)
{
	if(CFrameWnd::OnCreate(lpcs)==-1) return -1;

	SetTimer(TIMER_FLASH,DELAY_FLASH,NULL);
	//SetTimer(TIMER_MOVE,DELAY_MOVE,NULL);

	bCharset.LoadBitmap(IDB_CHARSET);
	bBlocks.LoadBitmap(IDB_BLOCKS);
	bRight.LoadBitmap(IDB_RIGHT);

	pThread=AfxBeginThread(&move,this);
	pThread->ResumeThread();
	if(!myMidi.Create(IDM_MIDI,this)) MessageBox("Cannot Open MIDI File","Tetris");
	myMidi.SetVolume(100);
	myMidi.Play(true);

	return 0;
}

void CMainWindow::OnClose()
{
	pThread->SuspendThread();
	delete pThread;
	CFrameWnd::OnClose();
}

void drawSurround(CDC* dc)
{
	CDC bDc;
	bDc.CreateCompatibleDC (dc);
	bDc.SelectObject (&bBlocks);

	dc->PatBlt (0,PIECEY,7,GRIDY*BRICKY,BLACKNESS);
	for(int y=0;y<GRIDY*BRICKY;y+=6)
	{
		dc->BitBlt(8,PIECEY+y,8,6,&bDc,0,bBrick*BRICKY,SRCCOPY);
		dc->BitBlt(PIECEX+GRIDX*BRICKX,PIECEY+y,8,6,&bDc,0,bBrick*BRICKY,SRCCOPY);
	}
	bDc.SelectObject(&bRight);
	dc->BitBlt(PIECEX+(GRIDX+1)*BRICKX,PIECEY,56,GRIDY*BRICKY,&bDc,0,0,SRCCOPY);

}
void CMainWindow::OnPaint()
{
	CPaintDC dc(this);
	drawSurround(&dc);
	grid.setDC(&dc);
	grid.drawGridG();
	grid.updateInfoG();
}

void CMainWindow::OnTimer(UINT nTimerID)
{
	if(grid.flash)
	{
		CClientDC dc(this);
		grid.setDC(&dc);
		grid.doFlashG();
	}
}
void CMainWindow::OnKeyUp(UINT nKey,UINT,UINT)
{
	switch(nKey)
	{
	case K_LEFT:
		knextleft=kleft=false;
		break;
	case K_RIGHT:
		knextright=kright=false;
		break;
	case K_ANTICLOCK:
		kaclock=false;
		break;
	case K_CLOCK:
		kclock=false;
		break;
	case K_DOWN:
		kstopdown=kdown=false;
		break;
	default:
		break;
	}
}

void CMainWindow::OnKeyDown(UINT nKey,UINT,UINT)
{
	CClientDC dc(this);

	if(grid.flash) return;
	grid.setDC(&dc);
	switch(nKey)
	{
	case K_LEFT:
		if(!kleft)
		{
			kleft=true;
			grid.moveLeftG();
		}
		break;
	case K_RIGHT:
		if(!kright)
		{
			kright=true;
			grid.moveRightG();
		}
		break;
	case K_ANTICLOCK:
		if(!kaclock)
		{
			kaclock=true;
			grid.rotAClockG();
		}
		break;
	case K_CLOCK:
		if(!kclock)
		{
			kclock=true;
			grid.rotClockG();
		}
		break;
	case K_DOWN:
		if(!kstopdown)
			kdown=true;
		break;
	case K_FULLDOWN:
		grid.moveDownFullG();
	default:
		break;
	}
}
