enum keys {
	K_LEFT=VK_LEFT,
	K_RIGHT=VK_RIGHT,
	K_CLOCK=VK_UP,
	K_ANTICLOCK=VK_SPACE,
	K_DOWN=VK_DOWN,
	K_FULLDOWN=VK_RETURN
};

enum timer_ids {
	TIMER_FLASH,
};

enum timer_intervals {
	DELAY_MOVE=15,
	DELAY_FLASH=100,
	IDOWNRATIO=32
};
enum positions {
	GRIDX=10,
	GRIDY=18,
	BRICKX=8,
	BRICKY=8,
	PIECEX=16,
	PIECEY=0,
	PREVIEWX=13,
	PREVIEWY=12
};

//************************************************************
const int lineScore[4] = { 40,100,300,1200 };
//************************************************************


class CMyApp : public CWinApp
{
public:
	virtual BOOL InitInstance();
};

class CMainWindow : public CFrameWnd
{
public:
	CMainWindow();
protected:
	afx_msg int OnCreate(LPCREATESTRUCT);
	afx_msg void OnClose();
	afx_msg void OnPaint();
	afx_msg void OnTimer(UINT);
	afx_msg void OnKeyUp(UINT,UINT,UINT);
	afx_msg void OnKeyDown(UINT,UINT,UINT);

	DECLARE_MESSAGE_MAP()
private:
	CWinThread* pThread;
};

typedef char chars;

class CGText
{
public:
	enum ichars{
		c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,
		cA,cB,cC,cD,cE,cF,cG,cH,cI,cJ,
		cK,cL,cM,cN,cO,cP,cQ,cR,cS,cT,
		cU,cV,cW,cX,cY,cZ,
	// Special Characters
		cDot,
		cMinus,
		cCross,
	// Non displaying characters
		cSpace,
		cNewL
	};
	CGText();
	CGText(chars chr);
	CGText(const char* text);
	CGText(int num);
	chars index(int i);
//	CGText operator+(CGText& other);
	~CGText();

	int len;
private:
	chars* rep;
};
void printG(CGText& text, CDC* pdc, int x, int y, bool right);
void GameMove(bool);
UINT move(LPVOID lp);
//************************************************************

enum bitmaps {
	bInvL,
	bL,
	bSquare,
	bT,
	bS,
	bInvS,
	bHLine1,
	bHLine2,
	bHLine3,
	bVLine1,
	bVLine2,
	bVLine3,
	bEndFill,
	bBackPattern,
	bHeart,
	bBrick
};
const bitmaps line [4][4] = {
	bHLine3, bHLine2, bHLine2, bHLine1,
	bVLine3, bVLine2, bVLine2, bVLine1,
	bHLine3, bHLine2, bHLine2, bHLine1,
	bVLine3, bVLine2, bVLine2, bVLine1
};

//struct relpt { char x,y };
//struct blocks { relpt block[4] };
//struct rotation { blocks rot[4] };
//struct pieces { rotation piece[7] };
//block.piece[0].rot[2].block[1].x
const char blockData[7][4][4][2]= { //[piece no][rotation][block no][coord]
	{{{2,3},{2,2},{1,2},{0,2}}, //--|
	 {{1,3},{0,3},{1,2},{1,1}},
	 {{2,2},{1,2},{0,2},{0,1}},
	 {{1,3},{1,2},{2,1},{1,1}}},

	{{{0,3},{2,2},{1,2},{0,2}}, //|--
	 {{1,3},{1,2},{1,1},{0,1}},
	 {{2,1},{2,2},{1,2},{0,2}},
	 {{2,3},{1,3},{1,2},{1,1}}}, 

	{{{2,3},{1,3},{2,2},{1,2}}, // ||
	 {{2,3},{1,3},{2,2},{1,2}},
	 {{2,3},{1,3},{2,2},{1,2}},
	{{2,3},{1,3},{2,2},{1,2}}},

	{{{1,3},{2,2},{1,2},{0,2}}, //-|-
	 {{1,3},{1,2},{1,1},{0,2}},
	 {{2,2},{1,2},{1,1},{0,2}},
	{{2,2},{1,3},{1,2},{1,1}}},

	{{{2,2},{1,3},{1,2},{0,3}}, //_|-
	 {{1,3},{1,2},{0,2},{0,1}},
	 {{2,2},{1,3},{1,2},{0,3}},
	 {{1,3},{1,2},{0,2},{0,1}}},

	{{{2,3},{1,3},{1,2},{0,2}}, //-|_
	 {{1,2},{1,1},{0,3},{0,2}},
	 {{2,3},{1,3},{1,2},{0,2}},
	 {{1,2},{1,1},{0,3},{0,2}}},

	{{{3,2},{2,2},{1,2},{0,2}}, //----
	 {{1,3},{1,2},{1,1},{1,0}},
	 {{3,2},{2,2},{1,2},{0,2}},
	 {{1,3},{1,2},{1,1},{1,0}}}
};
class CPiece
{
public:
	CPiece()
	{
		next();
	}
	CPiece(int t, int r)
	:type(t), rotation(r)
	{
	}
	int next();
	void rotAClock();
	void rotClock();
	int getX(int block, int x);
	int getY(int bllock, int y);
	void DrawG(CDC *dc, int x, int y);
	void EraseG(CDC *dc, int x, int y);
//protected:
	int type, rotation;
//private:
};

class CGrid
{
public:
	CGrid();
	bool available(CPiece& piece, int ax, int ay);
	void drawGridG();
	void bltGridG();
	void moveDownFullG();

	bool timerDownG();
	bool moveDownG();
	void downG();
	void removeLinesG();
	void updateInfoG();
	void doFlashG();
	
	void moveLeftG();
	void moveRightG();
	void rotClockG();
	void rotAClockG();
	
	void setDC(CDC *pdc);
	
	int flash;
private:
	CDC *dc;
	CPiece piece,preview;
	char store[GRIDY][GRIDX];
	char lines[4];
	int ix, iy;
	int downCount, lcount;
	int ilines, ilevel, iscore;
};
